#!/usr/bin/env python

"""
Example of writing values from Domoticz to a 20x4 LCD
Decide what info you want to display, and change idx's
and lcd_display_string values in domoticzGetValues accordingly.

Also change domo to your Domoticz url and port
"""

import i2c_driver
import time
import datetime
import requests
import json
#import unicodedata

mylcd = i2c_driver.lcd()
i = 0
domo = "<Domoticz url:port"
domoReadURL = domo + '/json.htm?type=devices&rid='

# create custom character for pound sign
pos = 0
data = [6,8,8,28,8,9,22,0]
mylcd.lcd_create_char(pos, data)
p = chr(0)

def domoticzRead(idx, var):
	url = domoReadURL + str(idx)
	response = requests.get(url)
	jsonData = json.loads(response.text)
	result = jsonData['result'][0][var]
	return result

def domoticzGetValues():
	heat_curr = str(domoticzRead(30,"Temp"))
	heat_setp = str(domoticzRead(31,"Temp"))
	heat_state = domoticzRead(193,"Data")
	temp = domoticzRead(345,"Data")
	elec_usage = temp[:temp.find(".")+2] + temp.split(" ")[1]
	if temp.find(".") == 1: elec_usage = " " + elec_usage
	temp = domoticzRead(300,"Data")
	elec_cost = str((float(temp.split(" ")[0])+0.05)/100)[:-2]
	temp = domoticzRead(366,"Data")
	gas_usage = temp[:temp.find(".")+2] + temp.split(" ")[1]
	if temp.find(".") == 1: gas_usage = " " + gas_usage
	temp = domoticzRead(365,"Data")
	gas_cost = str((float(temp.split(" ")[0])+0.05)/100)[:-2]
	mylcd.lcd_clear()
	mylcd.lcd_display_string("Heat " + heat_curr + "C/" + heat_setp + "C " + heat_state,2)
	mylcd.lcd_display_string("Elec " + elec_usage + "/" + p + elec_cost,3)
	mylcd.lcd_display_string("Gas  " + gas_usage + "/" + p + gas_cost,4)

domoticzGetValues()

while True:
	now = datetime.datetime.now()
	
	hr = int(now.strftime('%-I'))
	if hr < 10:
		time_string = '%a %d/%m  %-I:%M:%S%P'
	else:
		time_string = '%a %d/%m %-I:%M:%S%P'
	mylcd.lcd_display_string(now.strftime(time_string), 1)
		
	sec = now.second
	if sec == 10 and i == 0:
	# get values from Domoticz
		domoticzGetValues()
		i = 1
	else:
		i = 0
	
	time.sleep(0.1)
